//+------------------------------------------------------------------+
//|                                                  CCI50 Zero line cross.mq4 |
//| Add a 50 bar CCI, a 25 bar CCI, and a 34 bar exponential moving average of the HLC typical price (calculated as (High + Low + Close) / 3)).
//| Wait until the 50 bar CCI crosses the zero line, while the 25 bar CCI is on the correct side of the zero line, and the price is on the correct side of the moving average.
// 
//  This means that if the 50 bar CCI crosses above the zero line, the 25 bar CCI should also be above the zero line, 
//  and the price should close above the moving average, and vice versa if the 50 bar CCI crosses below the zero line.
//  If either the 25 bar CCI is on the wrong side of the zero line, or the price is on the wrong side of the moving average
// (i.e. CCI crosses above, while price closes below the moving average), the trade has not met its requirements, and should not be entered.
//
//
//|
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+


extern bool UseHourTrade = true; // Time filter
extern int  FromHourTrade = 4; // start trading on this hour
extern int  ToHourTrade = 22; // end trading on this hour
extern bool UseLastPeriodPerams=false;// uses the high and low from last period for calculation


extern double TakeProfit = 277;
extern double Lots = 1.0;
extern double TrailingStop = 50;





extern int triggerType=1;
extern int stochPeriod_trigger1=14;
extern int cciPeriod_trigger2=50;
extern int rsiPeriod_trigger3=13;



int       cciPeriod=50;



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
      
   double ATR;
   double BollingerSqueeze;
   double RSI;
   double RSI4;
   double RSI21;
   double RSIbefore;
   double CCI;
   double CCI21;
   double CCI50;
   double CCI50Before;
   double CCI100;
   double Stoch;
   double Stochsig;
   double BarVolume;
   double ADX;
   double ADXsig;
   
   double adx=0;
   double plusdi=0;
   double minusdi=0;
   double Twelve;
   double ThirtyFive;
   

   
   
// double blueB = iCustom( NULL, 0, "iBollinger Squeeze v4", totalBars, bolProd, bolDev, keltPrd, keltFactor, momPrd, alertBox, audioAlert, 0, shift );
    
   //  double blueB = iCustom( NULL, 0, "BollingerSqueeze", 31, 20, 2.0, 20, 1.5, 31, 14,"Hello",0, 0, 0 );

double blueB = iCustom( NULL, 0, "BollingerSqueeze", 55, 20, 2.0, 20, 1.5,"Hello",0, 1, 0 );
   
   




   
   string     Calc_data      = " Bollinger Bands Parameters ";
   int        Length         =    20;    // Bollinger Bands Period
   int        Deviation      =     2;    // Deviation
      
   string LastTradeTime=datetime;
   
   int cnt,ticket,tt=0, total;
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables

   
 //  double blueB = iCustom( NULL, 0, "BollingerSqueeze", 31, 20, 2.0, 20, 1.5, momPrd, alertBox, audioAlert, 0, shift );
   
   
   RSI4=iRSI(NULL,0,4,PRICE_CLOSE,0);
//   RSI=iRSI(NULL,0,21,PRICE_CLOSE,0);
//   RSI21=iRSI(NULL,0,21,PRICE_CLOSE,0);
//   RSIbefore=iRSI(NULL,0,21,PRICE_CLOSE,2);
//   CCI= iCCI(NULL,0,21,PRICE_CLOSE,0);
//   CCI21= iCCI(NULL,0,21,PRICE_CLOSE,0);
   CCI50= iCCI(NULL,0,50,PRICE_CLOSE,0);
//   CCI50Before= iCCI(NULL,0,50,PRICE_CLOSE,1);
   CCI100= iCCI(NULL,0,100,PRICE_CLOSE,0);
   Stoch=iStochastic(NULL,0,36,12,5,MODE_SMA,0,MODE_MAIN,0);
   Stochsig=iStochastic(NULL,0,36,12,5,MODE_SMA,0,MODE_SIGNAL,0);
//   BarVolume=iVolume(NULL,15,1);
   
//   adx = iCustom(NULL,0,"adxdon",14,34,34,0,0);
//   plusdi = iCustom(NULL,0,"adxdon",14,34,34,1,0);
//   minusdi = iCustom(NULL,0,"adxdon",14,34,34,2,0);
   


double upB = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 0,1);
double loB = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 1,1);
double upB2 = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 2,1);
double loB2 = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 3,1);
double mm = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 4,1);
double cciline = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 5,1);


   
  
   
double M34EMA= iMA(NULL,0,34,0,MODE_EMA,PRICE_TYPICAL,0);
   
   
   
  

  
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
 
 // check for long position (BUY) possibility
 
 
//  if ( ( Close[1]<= M34EMA && Close[0]>M34EMA && CCI50>22 && CCI50Before<0 && CCI21>133 && RSI4>56 && plusdi>minusdi && Stoch>30 && Stoch>Stochsig ) || ( Close[1]<=M34EMA && Close[0]>M34EMA && Stoch>Stochsig+3.431 && CCI50>10 && CCI21>44 && RSI21>46 && RSI4>75 ) || Close[2]<M34EMA && Close[1]<=M34EMA && Close[0]>M34EMA && plusdi>minusdi && Stoch>Stochsig+9.0 && CCI50>10 && CCI21>133 &&  RSI4>79  )    
    if ( Close[1]<=M34EMA && Close [0]> M34EMA )  
        {
//         Alert ("We have a 34 cross going up",Symbol());
//         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"Go Long",16384,0,Blue);
//         if(ticket>0)
//           {
//            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
//           }
//         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
  
  
        
        
      // check for short position (SELL) possibility && 
      // iRSI(NULL,0,14,PRICE_CLOSE,1) <  30
      // iVolume(Null,15,1)
        
//   if( ( Close[1]>M34EMA && Close[0]<M34EMA && CCI50<-22 && CCI50Before>0 && CCI21<-133  && RSI4<33 && RSI21<44 && minusdi>plusdi && Stoch<Stochsig ) || ( Close[1]>M34EMA && Close[0]<M34EMA && Stoch+6.5<Stochsig && CCI50<0 && CCI21<-122 && RSI4<30 && adx>7  ) )
     if ( Close[1]>=M34EMA && Close[0]<M34EMA )

        {
//         Alert ("We have a 34 cross going down",Symbol());
//         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"Go Short",16384,0,Orange);
//         if(ticket>0)
//           {
//            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
//           }
//         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
     
     
     
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            
            // Check Buy position - should it be closed?   
            
         if( ( CCI50<-99 ) || ( RSI4>95 ) || CCI50>302 ) 
         
                            {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                                
                  return(0); // exit
                  }
             
            
             
                  
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to check if short position should be closed 
           {
           
            // should it be closed?
             
           //   if ( ( CCI50<-280 && CCI21>-89 )  || ( RSI4<4.7 && RSI21<29.5  ) || ( Stoch<16.11)  )
             
             if(  Stoch>Stochsig && CCI100>0 && CCI50>66 ) 
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow); // close position
               return(0); // exit
               
              }
            // check for trailing stop
                        
            if(TrailingStop>0)  
              { 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.